// subpages/evaluationIntroduction/evaluationIntroduction.js
Page({

  /**
   * 页面的初始数据
   */
  data: {
    type: "physique",//报告类型
    testSize: 9,
    comScoreIndex:6,
    testTitle: "睡眠质量指数评测",
    testDesc: "本测评系统依据山东睡眠质量指数量表(SDPSQI)开发。\nSDPSO1由山东省中医药大学医学中心精神科睡眠和生物节律研究中心睡眠专家组编制，专门用于评定被试者近一个月的主观睡眠质量。SDPSQI作为一种科学、系统的睡眠质量评估工具为了解个体睡眠状况、诊断睡眠障碍以及制定相应的干预措施提供了重要的工具和平台。",
    isHaveRes: false,//是否有测试过
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    console.log(options);

    if (options.type) {
      var type = options.type;
      var testTitle = "";
      var testDesc = "";
      var testSize = 9;
      if (type == "physique") {
        // 体质
        testSize = 9;
        testTitle = "体质诊断检测";
        testDesc = "本测试表由山东省中医药大学中医专家组(具有中医针灸师、中医芳香疗法指导师、医院临床检验科资质的主任医师们)提出。中医学依据气、血、水的平衡状态，将人分为六种体质。要改善身体的“不调”，最重要的就是先了解自己的体质。有人也可能是不同体质混合的“复合型”，而且人的体质日常是变化的，因此应根据每天变化的身体状态进行相应调理的养生疗法。我们根据人体部位分了八个方面，请从下面选项里选出和自己相符的项，提交后，系统会进行判断，并显示您的体质、分析和建议。";
        this.checkPhysiqueData()
      } else if (type == "sleep") {
        // 睡眠质量
        testSize = 25;
        testTitle = "睡眠质量指数评测";
        testDesc = "本测评系统依据山东睡眠质量指数量表(SDPSQI)开发。\nSDPSO1由山东省中医药大学医学中心精神科睡眠和生物节律研究中心睡眠专家组编制，专门用于评定被试者近一个月的主观睡眠质量。SDPSQI作为一种科学、系统的睡眠质量评估工具为了解个体睡眠状况、诊断睡眠障碍以及制定相应的干预措施提供了重要的工具和平台。";
      }
      this.setData({
        testSize,
        testTitle,
        testDesc,
        type
      })
    }

  },

  leftBack() {
    wx.navigateBack()
  },
  toTest() {
    // 去测试
    wx.setStorageSync("testType", this.data.type);
    wx.navigateTo({
      url: '/subpages/textStep/textStep?type=' + this.data.type
    })
  },
  toResult() {
    // 结果页
    if (this.data.type == "physique") {
      // 体质
      wx.navigateTo({
        url: `/subpages/testResultB/testResultB?comScoreIndex=${this.data.comScoreIndex}`
      })
    } else if (this.data.type == "sleep") {
      // 睡眠质量
      wx.navigateTo({
        url: '/subpages/testResultA/testResultA'
      })
    }
  },
 checkPhysiqueData() {
    var that = this;
    var userId = wx.getStorageSync("unionid");
    wx.request({
      url: `https://fare.somnisix.top/system/constitutionDiagnosis/user/${userId}`,
      data: {
        "token": "eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6Ijk5YzI3MjI2LTdkOWQtNDhiOC1hYjlhLWM4YjVjYWZiZGNkNyIsInVzZXJuYW1lIjoiYWRtaW4ifQ.zITQOINFkHs19_1RAgHS4I9YMaVxVq0Dsn3t6r_K7rv3rXvJy0sMtodejIMi_PNa_m4uQYxnU-6k3wC2LZht_Q"
      },
      header: {
        'Authorization': 'Bearer ' + "eyJhbGciOiJIUzUxMiJ9.eyJ1c2VyX2lkIjoxLCJ1c2VyX2tleSI6Ijk5YzI3MjI2LTdkOWQtNDhiOC1hYjlhLWM4YjVjYWZiZGNkNyIsInVzZXJuYW1lIjoiYWRtaW4ifQ.zITQOINFkHs19_1RAgHS4I9YMaVxVq0Dsn3t6r_K7rv3rXvJy0sMtodejIMi_PNa_m4uQYxnU-6k3wC2LZht_Q" // 在头部设置Bearer Token
      },
      method: 'GET',
      success(res) {
        try {
          if (res && res.data && res.data.data) {
            if (res.data.data.value2) {
              var data = JSON.parse(res.data.data.value2);
              var maxValueObj = that.findMaxValueKeyAndIndex(data);
              that.setData({
                comScoreIndex: maxValueObj.index,
                isHaveRes: true
              })

            }
          }

        } catch (error) {
          console.error(error);
        }

      },
    })
  },

  // 体质的方法
  // 取出最大值的obj
  findMaxValueKeyAndIndex(obj) {
    if (typeof obj !== 'object' || obj === null || Array.isArray(obj)) {
      throw new Error('Input must be a plain object');
    }
    let maxKey = null;
    let maxValue = 0;
    let maxIndex = 6;

    const keys = Object.keys(obj);
    keys.forEach((key, index) => {
      const value = obj[key];
      if (value > maxValue) {
        maxValue = value;
        maxKey = key;
        maxIndex = index;
      }
    });

    return {
      key: maxKey,
      value: maxValue,
      index: maxIndex
    };
  },
  /**
   * A、B、C、D、E、F 最后积累的数量对比，按数量多少来判断，6个分别对应：气虚型、气滞型、血虚型、淤血型、水虚型、痰湿型
 * 找出对象中值最大的键
 * @param {Object} obj - 包含键值对的对象
 * @returns {string|null} - 值最大的键，如果没有找到则返回null
 */
  findKeyWithMaxValue(obj) {
    if (typeof obj !== 'object' || obj === null || Array.isArray(obj)) {
      throw new Error('Input must be a plain object');
    }

    let maxKey = null;
    let maxValue = 0;

    for (let key in obj) {
      if (obj.hasOwnProperty(key)) {
        if (obj[key] > maxValue) {
          maxValue = obj[key];
          maxKey = key;
        }
      }
    }

    return maxKey;
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    wx.removeStorageSync('testType');
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {
    var that = this;
    return {
      title: that.data.testTitle,
      path: '/subpages/evaluationIntroduction/evaluationIntroduction?type=' + that.data.type,
    }
  }
})